--- old/./mr_sas.c	Tue Nov  6 14:29:38 2012
+++ new/./mr_sas.c	Tue Nov  6 14:29:38 2012
@@ -5841,8 +6078,9 @@
 
 		/* means IOCTL requires DMA */
 		/* allocate the data transfer buffer */
-		//data_dma_obj.size = data_xferlen;
-		MRSAS_GET_BOUNDARY_ALIGNED_LEN(data_xferlen,new_xfer_length2,PAGESIZE);	
+		/* data_dma_obj.size = data_xferlen; */
+		MRSAS_GET_BOUNDARY_ALIGNED_LEN(data_xferlen, new_xfer_length2,
+		    PAGESIZE);
 		data_dma_obj.size = new_xfer_length2;
 		data_dma_obj.dma_attr = mrsas_generic_dma_attr;
 		data_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
@@ -5850,7 +6088,7 @@
 		data_dma_obj.dma_attr.dma_attr_sgllen = 1;
 		data_dma_obj.dma_attr.dma_attr_align = 1;
 
-/* allocate kernel buffer for DMA */
+		/* allocate kernel buffer for DMA */
 		if (mrsas_alloc_dma_obj(instance, &data_dma_obj,
 		    (uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
 			con_log(CL_ANN, (CE_WARN, "issue_mfi_stp: "
@@ -5931,6 +6169,7 @@
 	kstp->cmd_status = ddi_get8(acc_handle, &stp->cmd_status);
 	con_log(CL_ANN1, (CE_NOTE, "issue_mfi_stp: stp->cmd_status = %d",
 	    kstp->cmd_status));
+	DTRACE_PROBE2(issue_stp, uint8_t, kstp->cmd, uint8_t, kstp->cmd_status);
 
 	if (fis_xferlen) {
 		/* free kernel buffer */
@@ -6094,10 +6333,10 @@
 		cmd = get_mfi_pkt(instance);
 	}
 	if (!cmd) {
-		cmn_err(CE_WARN,
-		    "Failed to get a cmd from free-pool in handle_mfi_ioctl(). "
-			"fw_outstanding=0x%X max_fw_cmds=0x%X",
-			instance->fw_outstanding, instance->max_fw_cmds);
+		con_log(CL_ANN, (CE_WARN, "mr_sas: "
+		    "failed to get a cmd packet"));
+		DTRACE_PROBE2(mfi_ioctl_err, uint16_t,
+		    instance->fw_outstanding, uint16_t, instance->max_fw_cmds);
 		return (DDI_FAILURE);
 	}
 
@@ -6129,6 +6368,9 @@
 		break;
 	}
 
+	if (mrsas_common_check(instance, cmd) != DDI_SUCCESS)
+		rval = DDI_FAILURE;
+
 	if (instance->tbolt) {
 		return_raid_msg_mfi_pkt(instance, cmd);
 	} else {
@@ -6233,14 +6475,11 @@
 	}
 
 	if (!cmd) {
-		cmn_err(CE_WARN,
-		    "Failed to get a cmd from free-pool in register_mfi_aen(). "
-			"fw_outstanding=0x%X max_fw_cmds=0x%X",
-			instance->fw_outstanding, instance->max_fw_cmds);
+		DTRACE_PROBE2(mfi_aen_err, uint16_t, instance->fw_outstanding,
+		    uint16_t, instance->max_fw_cmds);
 		return (ENOMEM);
 	}
 
-
 	/* Clear the frame buffer and assign back the context id */
 	(void) memset((char *)&cmd->frame[0], 0, sizeof (union mrsas_frame));
 	ddi_put32(cmd->frame_dma_obj.acc_handle, &cmd->frame->hdr.context,
@@ -6305,31 +6544,31 @@
 	char		inquiry_buf[256] = {0};
 	int		len;
 	const char	*const scsi_device_types[] = {
-		"Direct-Access    ",
+		"Direct-Access	  ",
 		"Sequential-Access",
-		"Printer          ",
-		"Processor        ",
-		"WORM             ",
-		"CD-ROM           ",
-		"Scanner          ",
-		"Optical Device   ",
-		"Medium Changer   ",
-		"Communications   ",
-		"Unknown          ",
-		"Unknown          ",
-		"Unknown          ",
-		"Enclosure        ",
+		"Printer	  ",
+		"Processor	  ",
+		"WORM		  ",
+		"CD-ROM		  ",
+		"Scanner	  ",
+		"Optical Device	  ",
+		"Medium Changer	  ",
+		"Communications	  ",
+		"Unknown	  ",
+		"Unknown	  ",
+		"Unknown	  ",
+		"Enclosure	  ",
 	};
 
 	len = 0;
 
-	len += snprintf(inquiry_buf + len, 265 - len, "  Vendor: ");
+	len += snprintf(inquiry_buf + len, 265 - len, "	 Vendor: ");
 	for (i = 8; i < 16; i++) {
 		len += snprintf(inquiry_buf + len, 265 - len, "%c",
 		    scsi_inq[i]);
 	}
 
-	len += snprintf(inquiry_buf + len, 265 - len, "  Model: ");
+	len += snprintf(inquiry_buf + len, 265 - len, "	 Model: ");
 
 	for (i = 16; i < 32; i++) {
 		len += snprintf(inquiry_buf + len, 265 - len, "%c",
@@ -6336,7 +6575,7 @@
 		    scsi_inq[i]);
 	}
 
-	len += snprintf(inquiry_buf + len, 265 - len, "  Rev: ");
+	len += snprintf(inquiry_buf + len, 265 - len, "	 Rev: ");
 
 	for (i = 32; i < 36; i++) {
 		len += snprintf(inquiry_buf + len, 265 - len, "%c",
@@ -6349,13 +6588,13 @@
 	i = scsi_inq[0] & 0x1f;
 
 
-	len += snprintf(inquiry_buf + len, 265 - len, "  Type:   %s ",
+	len += snprintf(inquiry_buf + len, 265 - len, "	 Type:	 %s ",
 	    i < MAX_SCSI_DEVICE_CODE ? scsi_device_types[i] :
-	    "Unknown          ");
+	    "Unknown	      ");
 
 
 	len += snprintf(inquiry_buf + len, 265 - len,
-	    "                 ANSI SCSI revision: %02x", scsi_inq[2] & 0x07);
+	    "		      ANSI SCSI revision: %02x", scsi_inq[2] & 0x07);
 
 	if ((scsi_inq[2] & 0x07) == 1 && (scsi_inq[3] & 0x0f) == 1) {
 		len += snprintf(inquiry_buf + len, 265 - len, " CCS\n");
@@ -6366,7 +6605,7 @@
 	con_log(CL_DLEVEL2, (CE_CONT, inquiry_buf));
 }
 
-void
+static void
 io_timeout_checker(void *arg)
 {
 	struct scsi_pkt *pkt;
@@ -6389,17 +6628,18 @@
 
 	/* See if this check needs to be in the beginning or last in ISR */
 	if (mrsas_initiate_ocr_if_fw_is_faulty(instance) ==  1) {
-		cmn_err(CE_WARN, "io_timeout_checker:"
+		cmn_err(CE_WARN, "io_timeout_checker: "
 		    "FW Fault, calling reset adapter");
-		cmn_err(CE_CONT, "io_timeout_checker: fw_outstanding 0x%X max_fw_cmds 0x%X",
-			instance->fw_outstanding, instance->max_fw_cmds );
+		cmn_err(CE_CONT, "io_timeout_checker: "
+		    "fw_outstanding 0x%X max_fw_cmds 0x%X",
+		    instance->fw_outstanding, instance->max_fw_cmds);
 		if (instance->adapterresetinprogress == 0) {
-			instance->adapterresetinprogress = 1;  
+			instance->adapterresetinprogress = 1;
 			if (instance->tbolt)
-				mrsas_tbolt_reset_ppc(instance);
+				(void) mrsas_tbolt_reset_ppc(instance);
 			else
-				mrsas_reset_ppc(instance);
-			instance->adapterresetinprogress = 0;	
+				(void) mrsas_reset_ppc(instance);
+			instance->adapterresetinprogress = 0;
 		}
 		instance->timeout_id = timeout(io_timeout_checker,
 		    (void *) instance, drv_usectohz(MRSAS_1_SECOND));
@@ -6422,7 +6662,7 @@
 				continue;
 			}
 			time = --cmd->drv_pkt_time;
-		} else {     
+		} else {
 			pkt = cmd->pkt;
 			if (pkt == NULL) {
 				continue;
@@ -6431,9 +6671,10 @@
 		}
 		if (time <= 0) {
 			cmn_err(CE_WARN, "%llx: "
-			    "io_timeout_checker: TIMING OUT: pkt "
-			    ": %p, cmd %p fw_outstanding 0x%X max_fw_cmds 0x%X\n",
-				gethrtime(), (void *)pkt, (void *)cmd, instance->fw_outstanding, instance->max_fw_cmds);
+			    "io_timeout_checker: TIMING OUT: pkt: %p, "
+			    "cmd %p fw_outstanding 0x%X max_fw_cmds 0x%X\n",
+			    gethrtime(), (void *)pkt, (void *)cmd,
+			    instance->fw_outstanding, instance->max_fw_cmds);
 
 			counter++;
 			break;
@@ -6443,27 +6684,31 @@
 
 	if (counter) {
 		if (instance->disable_online_ctrl_reset == 1) {
-			cmn_err(CE_WARN, "mr_sas %d: %s(): OCR is NOT supported by Firmware, KILL adapter!!!",
-		            instance->instance, __func__);
+			cmn_err(CE_WARN, "mr_sas %d: %s(): OCR is NOT "
+			    "supported by Firmware, KILL adapter!!!",
+			    instance->instance, __func__);
 
 			if (instance->tbolt)
-				(void) mrsas_tbolt_kill_adapter(instance);
+				mrsas_tbolt_kill_adapter(instance);
 			else
 				(void) mrsas_kill_adapter(instance);
 
 			return;
 		} else {
-			if (cmd->retry_count_for_ocr <=  IO_RETRY_COUNT) {
+			if (cmd->retry_count_for_ocr <=	 IO_RETRY_COUNT) {
 				if (instance->adapterresetinprogress == 0) {
-					if (instance->tbolt)
-						mrsas_tbolt_reset_ppc(instance);
-					else
-						mrsas_reset_ppc(instance);
+					if (instance->tbolt) {
+						(void) mrsas_tbolt_reset_ppc(
+						    instance);
+					} else {
+						(void) mrsas_reset_ppc(
+						    instance);
+					}
 				}
 			} else {
 				cmn_err(CE_WARN,
 				    "io_timeout_checker: "
-					"cmd %p cmd->index %d "
+				    "cmd %p cmd->index %d "
 				    "timed out even after 3 resets: "
 				    "so KILL adapter", (void *)cmd, cmd->index);
 
@@ -6470,7 +6715,7 @@
 				mrsas_print_cmd_details(instance, cmd, 0xDD);
 
 				if (instance->tbolt)
-					(void) mrsas_tbolt_kill_adapter(instance);
+					mrsas_tbolt_kill_adapter(instance);
 				else
 					(void) mrsas_kill_adapter(instance);
 				return;
@@ -6518,7 +6763,6 @@
 	}
 
 	mutex_enter(&instance->reg_write_mtx);
-	ASSERT(mutex_owned(&instance->reg_write_mtx));
 	/* Issue the command to the FW */
 	WR_IB_QPORT((cmd->frame_phys_addr) |
 	    (((cmd->frame_count - 1) << 1) | 1), instance);
@@ -6559,7 +6803,6 @@
 	cmd->cmd_status	= ENODATA;
 
 	mutex_enter(&instance->reg_write_mtx);
-	ASSERT(mutex_owned(&instance->reg_write_mtx));
 	/* Issue the command to the FW */
 	WR_IB_QPORT((cmd->frame_phys_addr) |
 	    (((cmd->frame_count - 1) << 1) | 1), instance);
@@ -6598,7 +6841,7 @@
 	ddi_put8(cmd->frame_dma_obj.acc_handle, &frame_hdr->cmd_status,
 	    MFI_CMD_STATUS_POLL_MODE);
 	flags = ddi_get16(cmd->frame_dma_obj.acc_handle, &frame_hdr->flags);
-	flags 	|= MFI_FRAME_DONT_POST_IN_REPLY_QUEUE;
+	flags	|= MFI_FRAME_DONT_POST_IN_REPLY_QUEUE;
 
 	ddi_put16(cmd->frame_dma_obj.acc_handle, &frame_hdr->flags, flags);
 
@@ -6683,6 +6926,11 @@
 		ret = DDI_INTR_UNCLAIMED;
 	}
 
+	if (mrsas_check_acc_handle(instance->regmap_handle) != DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+		ret = DDI_INTR_UNCLAIMED;
+	}
+
 	if (ret == DDI_INTR_UNCLAIMED) {
 		return (ret);
 	}
@@ -6710,7 +6958,7 @@
 		return (DDI_FAILURE);
 
 	con_log(CL_ANN1, (CE_NOTE, "mrsas_kill_adapter: "
-		"Writing to doorbell with MFI_STOP_ADP "));
+	    "Writing to doorbell with MFI_STOP_ADP "));
 	mutex_enter(&instance->ocr_flags_mtx);
 	instance->deadadapter = 1;
 	mutex_exit(&instance->ocr_flags_mtx);
@@ -6760,7 +7008,7 @@
 		status = RD_OB_DRWE(instance);
 		if (retry++ == 100) {
 			cmn_err(CE_WARN, "mrsas_reset_ppc: DRWE bit "
-			    "check retry count %d\n", retry);
+			    "check retry count %d", retry);
 			return (DDI_FAILURE);
 		}
 	}
@@ -6771,8 +7019,8 @@
 		delay(100 * drv_usectohz(MILLISEC));
 		status = RD_OB_DRWE(instance);
 		if (retry++ == 100) {
-			cmn_err(CE_WARN,
-				"mrsas_reset_ppc: RESET FAILED. KILL adapter called\n.");
+			cmn_err(CE_WARN, "mrsas_reset_ppc: "
+			    "RESET FAILED. KILL adapter called.");
 
 			(void) mrsas_kill_adapter(instance);
 			return (DDI_FAILURE);
@@ -6807,14 +7055,15 @@
 			    < MAX_FW_RESET_COUNT) {
 				cmn_err(CE_WARN, "mrsas_reset_ppc: "
 				    "FW is in fault after OCR count %d "
-					"Retry Reset",
+				    "Retry Reset",
 				    instance->fw_fault_count_after_ocr);
 				goto retry_reset;
 
 			} else {
 				cmn_err(CE_WARN, "mrsas_reset_ppc: "
-					"Max Reset Count exceeded >%d"
-				    "Mark HBA as bad, KILL adapter", MAX_FW_RESET_COUNT);
+				    "Max Reset Count exceeded >%d"
+				    "Mark HBA as bad, KILL adapter",
+				    MAX_FW_RESET_COUNT);
 
 				(void) mrsas_kill_adapter(instance);
 				return (DDI_FAILURE);
@@ -6855,7 +7104,7 @@
 	    "Calling mrsas_issue_pending_cmds"));
 	(void) mrsas_issue_pending_cmds(instance);
 	con_log(CL_ANN1, (CE_NOTE, "mrsas_reset_ppc: "
-	"issue_pending_cmds done.\n"));
+	    "issue_pending_cmds done.\n"));
 
 	con_log(CL_ANN1, (CE_NOTE, "mrsas_reset_ppc: "
 	    "Calling aen registration"));
@@ -6877,8 +7126,184 @@
 	return (DDI_SUCCESS);
 }
 
+/*
+ * FMA functions.
+ */
+int
+mrsas_common_check(struct mrsas_instance *instance, struct  mrsas_cmd *cmd)
+{
+	int ret = DDI_SUCCESS;
 
+	if (cmd != NULL &&
+	    mrsas_check_dma_handle(cmd->frame_dma_obj.dma_handle) !=
+	    DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_UNAFFECTED);
+		if (cmd->pkt != NULL) {
+			cmd->pkt->pkt_reason = CMD_TRAN_ERR;
+			cmd->pkt->pkt_statistics = 0;
+		}
+		ret = DDI_FAILURE;
+	}
+	if (mrsas_check_dma_handle(instance->mfi_internal_dma_obj.dma_handle)
+	    != DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_UNAFFECTED);
+		if (cmd != NULL && cmd->pkt != NULL) {
+			cmd->pkt->pkt_reason = CMD_TRAN_ERR;
+			cmd->pkt->pkt_statistics = 0;
+		}
+		ret = DDI_FAILURE;
+	}
+	if (mrsas_check_dma_handle(instance->mfi_evt_detail_obj.dma_handle) !=
+	    DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_UNAFFECTED);
+		if (cmd != NULL && cmd->pkt != NULL) {
+			cmd->pkt->pkt_reason = CMD_TRAN_ERR;
+			cmd->pkt->pkt_statistics = 0;
+		}
+		ret = DDI_FAILURE;
+	}
+	if (mrsas_check_acc_handle(instance->regmap_handle) != DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_UNAFFECTED);
+
+		ddi_fm_acc_err_clear(instance->regmap_handle, DDI_FME_VER0);
+
+		if (cmd != NULL && cmd->pkt != NULL) {
+			cmd->pkt->pkt_reason = CMD_TRAN_ERR;
+			cmd->pkt->pkt_statistics = 0;
+		}
+		ret = DDI_FAILURE;
+	}
+
+	return (ret);
+}
+
+/*ARGSUSED*/
 static int
+mrsas_fm_error_cb(dev_info_t *dip, ddi_fm_error_t *err, const void *impl_data)
+{
+	/*
+	 * as the driver can always deal with an error in any dma or
+	 * access handle, we can just return the fme_status value.
+	 */
+	pci_ereport_post(dip, err, NULL);
+	return (err->fme_status);
+}
+
+static void
+mrsas_fm_init(struct mrsas_instance *instance)
+{
+	/* Need to change iblock to priority for new MSI intr */
+	ddi_iblock_cookie_t fm_ibc;
+
+	/* Only register with IO Fault Services if we have some capability */
+	if (instance->fm_capabilities) {
+		/* Adjust access and dma attributes for FMA */
+		endian_attr.devacc_attr_access = DDI_FLAGERR_ACC;
+		mrsas_generic_dma_attr.dma_attr_flags = DDI_DMA_FLAGERR;
+
+		/*
+		 * Register capabilities with IO Fault Services.
+		 * fm_capabilities will be updated to indicate
+		 * capabilities actually supported (not requested.)
+		 */
+
+		ddi_fm_init(instance->dip, &instance->fm_capabilities, &fm_ibc);
+
+		/*
+		 * Initialize pci ereport capabilities if ereport
+		 * capable (should always be.)
+		 */
+
+		if (DDI_FM_EREPORT_CAP(instance->fm_capabilities) ||
+		    DDI_FM_ERRCB_CAP(instance->fm_capabilities)) {
+			pci_ereport_setup(instance->dip);
+		}
+
+		/*
+		 * Register error callback if error callback capable.
+		 */
+		if (DDI_FM_ERRCB_CAP(instance->fm_capabilities)) {
+			ddi_fm_handler_register(instance->dip,
+			    mrsas_fm_error_cb, (void*) instance);
+		}
+	} else {
+		endian_attr.devacc_attr_access = DDI_DEFAULT_ACC;
+		mrsas_generic_dma_attr.dma_attr_flags = 0;
+	}
+}
+
+static void
+mrsas_fm_fini(struct mrsas_instance *instance)
+{
+	/* Only unregister FMA capabilities if registered */
+	if (instance->fm_capabilities) {
+		/*
+		 * Un-register error callback if error callback capable.
+		 */
+		if (DDI_FM_ERRCB_CAP(instance->fm_capabilities)) {
+			ddi_fm_handler_unregister(instance->dip);
+		}
+
+		/*
+		 * Release any resources allocated by pci_ereport_setup()
+		 */
+		if (DDI_FM_EREPORT_CAP(instance->fm_capabilities) ||
+		    DDI_FM_ERRCB_CAP(instance->fm_capabilities)) {
+			pci_ereport_teardown(instance->dip);
+		}
+
+		/* Unregister from IO Fault Services */
+		ddi_fm_fini(instance->dip);
+
+		/* Adjust access and dma attributes for FMA */
+		endian_attr.devacc_attr_access = DDI_DEFAULT_ACC;
+		mrsas_generic_dma_attr.dma_attr_flags = 0;
+	}
+}
+
+int
+mrsas_check_acc_handle(ddi_acc_handle_t handle)
+{
+	ddi_fm_error_t de;
+
+	if (handle == NULL) {
+		return (DDI_FAILURE);
+	}
+
+	ddi_fm_acc_err_get(handle, &de, DDI_FME_VERSION);
+
+	return (de.fme_status);
+}
+
+int
+mrsas_check_dma_handle(ddi_dma_handle_t handle)
+{
+	ddi_fm_error_t de;
+
+	if (handle == NULL) {
+		return (DDI_FAILURE);
+	}
+
+	ddi_fm_dma_err_get(handle, &de, DDI_FME_VERSION);
+
+	return (de.fme_status);
+}
+
+void
+mrsas_fm_ereport(struct mrsas_instance *instance, char *detail)
+{
+	uint64_t ena;
+	char buf[FM_MAX_CLASS];
+
+	(void) snprintf(buf, FM_MAX_CLASS, "%s.%s", DDI_FM_DEVICE, detail);
+	ena = fm_ena_generate(0, FM_ENA_FMT1);
+	if (DDI_FM_EREPORT_CAP(instance->fm_capabilities)) {
+		ddi_fm_ereport_post(instance->dip, buf, ena, DDI_NOSLEEP,
+		    FM_VERSION, DATA_TYPE_UINT8, FM_EREPORT_VERSION, NULL);
+	}
+}
+
+static int
 mrsas_add_intrs(struct mrsas_instance *instance, int intr_type)
 {
 
@@ -6920,20 +7345,17 @@
 	 * only one interrupt. The framework can be extended later.
 	 */
 	instance->intr_htable_size = count * sizeof (ddi_intr_handle_t);
-	instance->intr_htable = kmem_zalloc(instance->intr_htable_size, KM_SLEEP);
-	if (instance->intr_htable == NULL) {
-		con_log(CL_ANN, (CE_WARN, "mrsas_add_intrs: "
-			"failed to allocate memory for intr-handle table"));
-		instance->intr_htable_size = 0;
-		return (DDI_FAILURE);
-	}
+	instance->intr_htable = kmem_zalloc(instance->intr_htable_size,
+	    KM_SLEEP);
+	ASSERT(instance->intr_htable);
 
-	flag = ((intr_type == DDI_INTR_TYPE_MSI) || (intr_type ==
-		DDI_INTR_TYPE_MSIX)) ? DDI_INTR_ALLOC_STRICT:DDI_INTR_ALLOC_NORMAL;
+	flag = ((intr_type == DDI_INTR_TYPE_MSI) ||
+	    (intr_type == DDI_INTR_TYPE_MSIX)) ?
+	    DDI_INTR_ALLOC_STRICT : DDI_INTR_ALLOC_NORMAL;
 
 	/* Allocate interrupt */
 	ret = ddi_intr_alloc(dip, instance->intr_htable, intr_type, 0,
-			count, &actual, flag);
+	    count, &actual, flag);
 
 	if ((ret != DDI_SUCCESS) || (actual == 0)) {
 		con_log(CL_ANN, (CE_WARN, "mrsas_add_intrs: "
@@ -7011,21 +7433,17 @@
 
 mrsas_free_handlers:
 	for (i = 0; i < actual; i++)
-	{
 		(void) ddi_intr_remove_handler(instance->intr_htable[i]);
-	}
 
 mrsas_free_handles:
 	for (i = 0; i < actual; i++)
-	{
 		(void) ddi_intr_free(instance->intr_htable[i]);
-	}
 
 mrsas_free_htable:
 	if (instance->intr_htable != NULL)
 		kmem_free(instance->intr_htable, instance->intr_htable_size);
 
-	instance->intr_htable =NULL;
+	instance->intr_htable = NULL;
 	instance->intr_htable_size = 0;
 
 	return (DDI_FAILURE);
@@ -7043,7 +7461,7 @@
 	/* Disable all interrupts first */
 	if (instance->intr_cap & DDI_INTR_FLAG_BLOCK) {
 		(void) ddi_intr_block_disable(instance->intr_htable,
-				instance->intr_cnt);
+		    instance->intr_cnt);
 	} else {
 		for (i = 0; i < instance->intr_cnt; i++) {
 			(void) ddi_intr_disable(instance->intr_htable[i]);
@@ -7060,7 +7478,7 @@
 	if (instance->intr_htable != NULL)
 		kmem_free(instance->intr_htable, instance->intr_htable_size);
 
-	instance->intr_htable =NULL;
+	instance->intr_htable = NULL;
 	instance->intr_htable_size = 0;
 
 }
@@ -7102,14 +7520,12 @@
 
 		if (lun == 0) {
 			rval = mrsas_config_ld(instance, tgt, lun, childp);
-		}
 #ifdef PDSUPPORT
-		else if ( instance->tbolt == 1 && lun != 0) {
-			rval = mrsas_tbolt_config_pd(instance, 
+		} else if (instance->tbolt == 1 && lun != 0) {
+			rval = mrsas_tbolt_config_pd(instance,
 			    tgt, lun, childp);
-		}
 #endif
-		else {
+		} else {
 			rval = NDI_FAILURE;
 		}
 
@@ -7148,7 +7564,7 @@
 
 #ifdef PDSUPPORT
 	/* Config PD devices connected to the card */
-	if(instance->tbolt) {
+	if (instance->tbolt) {
 		for (tgt = 0; tgt < instance->mr_tbolt_pd_max; tgt++) {
 			(void) mrsas_tbolt_config_pd(instance, tgt, 1, NULL);
 		}
@@ -7230,11 +7646,6 @@
 	}
 
 	sd = kmem_zalloc(sizeof (struct scsi_device), KM_SLEEP);
-	if (sd == NULL) {
-		con_log(CL_ANN1, (CE_WARN,
-			    "mrsas_config_ld: failed to allocate mem for scsi_device"));
-		return (NDI_FAILURE);
-	}
 	sd->sd_address.a_hba_tran = instance->tran;
 	sd->sd_address.a_target = (uint16_t)tgt;
 	sd->sd_address.a_lun = (uint8_t)lun;
@@ -7369,7 +7780,7 @@
 		kmem_free(mrevt, sizeof (struct mrsas_eventinfo));
 		return (DDI_FAILURE);
 	}
-
+	DTRACE_PROBE3(service_evt, int, tgt, int, lun, int, event);
 	return (DDI_SUCCESS);
 }
 
@@ -7389,16 +7800,15 @@
 		mutex_enter(&instance->config_dev_mtx);
 		dip = instance->mr_ld_list[mrevt->tgt].dip;
 		mutex_exit(&instance->config_dev_mtx);
-	}
-
 #ifdef PDSUPPORT
-	else {
+	} else {
 		mutex_enter(&instance->config_dev_mtx);
 		dip = instance->mr_tbolt_pd_list[mrevt->tgt].dip;
 		mutex_exit(&instance->config_dev_mtx);
-	}
 #endif
+	}
 
+
 	ndi_devi_enter(instance->dip, &circ1);
 	switch (mrevt->event) {
 	case MRSAS_EVT_CONFIG_TGT:
@@ -7407,14 +7817,13 @@
 			if (mrevt->lun == 0) {
 				(void) mrsas_config_ld(instance, mrevt->tgt,
 				    0, NULL);
-			}
 #ifdef PDSUPPORT
-			else if (instance->tbolt) {
+			} else if (instance->tbolt) {
 				(void) mrsas_tbolt_config_pd(instance,
 				    mrevt->tgt,
 				    1, NULL);
-			}
 #endif
+			}
 			con_log(CL_ANN1, (CE_NOTE,
 			    "mr_sas: EVT_CONFIG_TGT called:"
 			    " for tgt %d lun %d event %d",
@@ -7462,7 +7871,7 @@
 mrsas_mode_sense_build(struct scsi_pkt *pkt)
 {
 	union scsi_cdb		*cdbp;
-	uint16_t 		page_code;
+	uint16_t		page_code;
 	struct scsa_cmd		*acmd;
 	struct buf		*bp;
 	struct mode_header	*modehdrp;
@@ -7514,4 +7923,3 @@
 	}
 	return (NULL);
 }
-
